/* Copyright (c) 1988 Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

#ifndef EXTERNS_H
#define EXTERNS_H

#include "mycdef.h"
#include "../server/ipcf.h"
#if defined(_SEQUENT_) || defined(SOLARIS)
#include <sys/select.h>
#endif				/* _SEQUENT_ || SOLARIS */

extern fd_set fdset;		/* player fd set for select() */
extern fd_set ignorefds;	/* fds that are not to be polled */
extern char *fail;		/* failcode used by logerr */
extern int port_fd;
extern int highestfd;
extern struct timeval *polltimeout;	/* timeout value in msec for select() */
extern struct itimerval *polldelay;	/* timeout value in msec for select() */
extern struct Cbuf cbufs[MAX_USERS];	/* user packet buffers */
extern void s_didpoll _((int));
extern void mdb _((char *));
extern void s_new_user _((int));
extern void s_packet _((int, char *));
extern void s_lost_user _((int));

#endif				/* EXTERNS_H */
