/* Copyright (c) 1988 Carrick Sean Casey. All rights reserved. */

/* start listening on our official port */
/* returns socket for new connects */

#include <stdio.h>
#include "config.h"
#ifdef FCNTL
#include <fcntl.h>
#endif				/* FCNTL */
#ifdef SOLARIS
#include <sys/file.h>
#endif				/* SOLARIS */
#include <signal.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "functions.h"
#ifdef STRINGS_H
#include <strings.h>
#else
#include "mystrings.h"
#endif				/* STRINGS_H */
#include "externs.h"
#if defined(hpux) || defined(_SEQUENT_)
#include <sys/file.h>
#endif				/* hpux || _SEQUENT_ */

int
makenewport(host_name, port_number)
	char   *host_name;
	int     port_number;
{
	struct sockaddr_in saddr;
	int     one = 1;
	int     s, flags;

	/* insert host_name into address */
	bzero((char *) &saddr, sizeof(saddr));
	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = htonl(INADDR_ANY);
	saddr.sin_port = htons(port_number);

	/* create a socket */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("makenewport: gethostbyname");
		mdb("makenewport: gethostbyname");
		return (-1);
	}
	/* bind it to the inet address */
	if (bind(s, (struct sockaddr *) & saddr, sizeof(saddr)) < 0) {
		perror("makenewport: bind");
		perror("perror says:");
		return (-1);
	}
	/* start listening for connections */
	listen(s, 0);

	/* make it non-blocking */
	if (fcntl(s, F_SETFL, FNDELAY) < 0) {
		perror("makenewport: fcntl");
		mdb("makenewport: fcntl");
		return (-1);
	}
	/* Don't close on exec */
	flags = fcntl(s, F_GETFD, 0);
	flags = flags & ~FD_CLOEXEC;
	if (fcntl(s, F_SETFD, flags) < 0) {
		perror("CLOEXEC");
		mdb("CLOEXEC");
		exit(-1);
	}
	/* force occasional connection check */
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR,
		(char *) &one, sizeof(one)) < 0) {
		puts("makeport:setsockopt (makeport)");
		mdb("makeport:setsockopt (makeport)");
/*		return(-1);*/
	}
	one = 32767;		/* 262144 of my freebsd box, i'll pay it safe */
	if (setsockopt(s, SOL_SOCKET, SO_SNDBUF,
		(char *) &one, sizeof(one)) < 0) {
		perror("SO_SNDBUF");
		mdb("makeport.c:SO_SNDBUF");
	}
	/* allow us to handle problems gracefully */
	signal(SIGPIPE, SIG_IGN);

	port_fd = s;
	return (0);
}
