/* Copyright 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* primitive to print the motd */

#include <stdio.h>
#include <ndbm.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/stat.h>
#include <unistd.h>
#ifdef STRINGS_H
#include <strings.h>
#else
#include "../murgil/mystrings.h"
#endif				/* STRINGS_H */
#include "server.h"
#include "config.h"
#include "externs.h"

#ifndef _INCLUDE_HPUX_SOURCE
#define dbm_open(a, b)		dbm_open((a), (b), S_IRUSR | S_IWUSR)
#endif				/* _INCLUDE_HPUX_SOURCE */

void
s_motd(n, argc)
	int     n;
	int     argc;
{
	int     motd_fd;
	char    c;
	DBM    *db;
	char    key[64];
	datum   info, request;
	char    temp[256];
	int     i;

	motd_fd = open(ICBDMOTD, O_RDONLY);

	bzero(temp, 255);
/* if the file is there, list it, otherwise report error */
	if (motd_fd >= 0) {
		while ((i = read(motd_fd, &c, 1)) > 0) {
			if (c == '%') {
				i = read(motd_fd, &c, 1);
				if (i <= 0) {
					if (close(motd_fd) != 0) {
						sprintf(mbuf, "[ERROR] MOTD File Close: %s",
						    sys_errlist[errno]);
						mdb(mbuf);
					}
				}
				if (c == 'U') {
					if ((db = dbm_open(USERDB, O_RDONLY)) == NULL) {
						sprintf(mbuf, "[ERROR] User DB Open: %s",
						    sys_errlist[errno]);
						mdb(mbuf);
						if (close(motd_fd) != 0) {
							sprintf(mbuf,
							    "[ERROR] MOTD File Close: %s",
							    sys_errlist[errno]);
							mdb(mbuf);
/*							return -1; */
							return;
						}
					}
					strcpy(key, "server.signon");
					request.dptr = key;
					request.dsize = strlen(key);
					info = dbm_fetch(db, request);
					if (info.dptr)
						strncat(temp, info.dptr, info.dsize);
					dbm_close(db);
				} else
					strncat(temp, &c, 1);
			} else
				if (c == '\012') {
					sends_cmdout(n, temp);
					bzero(temp, 255);
				} else
					strncat(temp, &c, 1);
		}
		if (close(motd_fd) != 0) {
			sprintf(mbuf, "[ERROR] MOTD File Close: %s",
			    sys_errlist[errno]);
			mdb(mbuf);
		}
	} else {
		sprintf(mbuf, "[ERROR] MOTD File Open: %s",
		    sys_errlist[errno]);
		mdb(mbuf);
		senderror(n, "No MOTD file found.");
	}
}
