/* Copyright (c) 1990 by Carrick Sean Casey. */
/* Modified 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* This file contains routines that are unix dependent. */
/* Eventually, most unixisms should be moved here. */

#include <sys/types.h>
#ifndef SOLARIS
#include <sys/dir.h>
#endif				/* !SOLARIS */
#include <pwd.h>
#ifdef TIME_H
#include <time.h>
#endif				/* TIME_H */
#include "server.h"
#include "externs.h"

/* stash the current time in curtime */
void
gettime()
{
	time(&curtime);
}


/* set line buffering for an open file pointer */
/* output will be flushed every newline */

void
linebuffer(fp)
	FILE   *fp;
{
/* #ifdef _POSIX_SOURCE
	setlinebuf(fp);
#else */
	setvbuf(fp, (char *) NULL, _IOLBF, 0);
/* #endif */
}

void
clearargs(argc, argv)
	int     argc;
	char   *argv[];
{
	int     x;
	char   *cp;

	for (x = 1; x <= argc - 1; x++) {
		cp = argv[x];
		while (*cp)
			*cp++ = ' ';
	}
}
